=== debian/control ===
Source: binutils64
Section: devel
Priority: optional
Maintainer: YunQiang Su <syq@debian.org>
Build-Depends: debhelper (>= 11), bison, flex,
 dejagnu, chrpath, lsb-release, lib64z1-dev, g++-multilib,
 binutils-source (>= 2.34-6)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/toolchain-team/binutils64
Vcs-Git: https://salsa.debian.org/toolchain-team/binutils64.git

Package: binutils64
Architecture: i386 powerpc mips mipsel mips mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
Depends: ${shlibs:Depends}, binutils-common, binutils
Suggests: binutils-doc
Description: GNU assembler, linker and binary utilities (64bit for 32bit)
 The programs in this package are used to assemble, link and manipulate
 binary and object files.  They may be used in conjunction with a compiler
 and various libraries to build programs.
 .
 This is built target for 32bit, while host for 64bit.

Package: binutils64-dbg
Section: debug
Architecture: i386 powerpc mips mipsel mips mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
Depends: binutils64
Description: GNU assembler, linker and binary utilities (64bit for 32bit, debug symbols)
 This package provides debug symbols for binutils64.
